# -*- coding utf-8 -*-
# environment_generator.py

from Env import FiniteStateFiniteActionLinearMDP
import argparse

parser = argparse.ArgumentParser(description='Randomly create a finite-state finite-action Linear MDP environment.')
parser.add_argument('-H', type=int, help='the length of horizon')
parser.add_argument('-S', type=int, help='the number of states')
parser.add_argument('-A', type=int, help='the number of actions')
parser.add_argument('-d', type=int, help='the number of dimensions of feature')
parser.add_argument('-name', type=str, help='the name of the creating environment')
args = parser.parse_args()

env = FiniteStateFiniteActionLinearMDP(H=args.H, S=args.S, A=args.A, d=args.d)
env.save_env(args.name)